// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe,Mathematik,Gnuplot)
#include <cstdlib>
#include <stdio.h>
#include <math.h>
#include "hilf.h"
#include "vector2.h"  
#include <iostream>
#include "graphik.h"
using namespace std;

// Programm berechnet Pseudozufallszahlen nach linearem Kongruenzgenerator
// Ausgabe: entweder alle Zufallszahlen oder graphisch 
//          ein Vektor aller Tripel aufeinanderfolgender Zahlen
int main()
{ long int m,a,c,z0,z;
  long int k,n;
  float xold,x1,x;
  char ausg;

  // nur fuer Graphik
  double* xw;
  double* yw;
  double* zw;
  //

  cout<< "m, a, c eingeben:";
  cin >> m >> a>> c;
  z0=time(0); // Initialisierung ueber die Zeit
  cout<< "n eingeben:";
  cin >> n;

  // fuer die Graphik
  xw=(double*)malloc(n*sizeof(double)); 
  yw=(double*)malloc(n*sizeof(double));
  zw=(double*)malloc(n*sizeof(double));
  //

  z=z0;
  for (k=1;k<n+1;k++)
    {
      z=(a*z+c)%m;
      xold=x1;
      x1=x;
      x=float(z)/float(m);

      // Hyperebenen fuer die Graphik
      if (k>2)
	{
          xw[k-3]=xold;
          yw[k-3]=x1;
          zw[k-3]=x;
        }
      //

    }
  cout<<"Graphische Ausgabe (g), Zahlenausgabe (z)?";
  cin >>ausg;
  if (ausg=='g')
    PlotResults3D(xw,yw,zw,n-2);
  else if (ausg=='z')
    ausgabe(zw,n-2);
  
  free(xw);
  free(yw);
  free(zw);
 
  return 0;
}
